
#define SPI_CLK_HI()	assert_param(IS_GPIO_ALL_PERIPH(SPI_CLK_PORT)); assert_param(IS_GPIO_PIN(SPI_CLK_PIN)); SPI_CLK_PORT->BSRR = SPI_CLK_PIN
#define SPI_CLK_LO()	assert_param(IS_GPIO_ALL_PERIPH(SPI_CLK_PORT)); assert_param(IS_GPIO_PIN(SPI_CLK_PIN)); SPI_CLK_PORT->BRR = SPI_CLK_PIN
#define SPI_MOSI_HI()	assert_param(IS_GPIO_ALL_PERIPH(SPI_MOSI_PORT)); assert_param(IS_GPIO_PIN(SPI_MOSI_PIN)); SPI_MOSI_PORT->BSRR = SPI_MOSI_PIN
#define SPI_MOSI_LO()	assert_param(IS_GPIO_ALL_PERIPH(SPI_MOSI_PORT)); assert_param(IS_GPIO_PIN(SPI_MOSI_PIN)); SPI_MOSI_PORT->BRR = SPI_MOSI_PIN
#define SPI_MISO_HI()	(GPIO_ReadInputDataBit(SPI_MISO_PORT, SPI_MISO_PIN))
#define SPI_MISO_LO()	!(GPIO_ReadInputDataBit(SPI_MISO_PORT, SPI_MISO_PIN))
#define SPI_SEL1_HI()	GPIO_SetBits(SPI_SEL1_PORT, SPI_SEL1_PIN)
#define SPI_SEL1_LO()	GPIO_ResetBits(SPI_SEL1_PORT, SPI_SEL1_PIN)
#define SPI_SEL2_HI()	GPIO_SetBits(SPI_SEL2_PORT, SPI_SEL2_PIN)
#define SPI_SEL2_LO()	GPIO_ResetBits(SPI_SEL2_PORT, SPI_SEL2_PIN)
#define SPI_SEL3_HI()	GPIO_SetBits(SPI_SEL3_PORT, SPI_SEL3_PIN)
#define SPI_SEL3_LO()	GPIO_ResetBits(SPI_SEL3_PORT, SPI_SEL3_PIN)
#define SPI_AD_HI()	GPIO_SetBits(SPI_AD_PORT, SPI_AD_PIN)
#define SPI_AD_LO()	GPIO_ResetBits(SPI_AD_PORT, SPI_AD_PIN)
#define SPI_RST_HI()	GPIO_SetBits(SPI_RST_PORT, SPI_RST_PIN)
#define SPI_RST_LO()	GPIO_ResetBits(SPI_RST_PORT, SPI_RST_PIN)

void SPI_Select1_HI ();
void SPI_Select1_LO ();
void SPI_Select2_HI ();
void SPI_Select2_LO ();
void SPI_Select3_HI ();
void SPI_Select3_LO ();
void SPI_AddressData_HI ();
void SPI_AddressData_LO ();
void SPI_Reset_HI ();
void SPI_Reset_LO ();

extern void SPI_HWInit (void);
extern uint8_t SPI_Write_Byte (uint8_t data);
extern uint8_t SPI_Read_Byte (void);
extern void SPI_Mode (uint8_t mode);
extern void SPI_Speed (uint16_t speed);
extern void SPI_Fast (void);
extern void SPI_Slow (void);
extern void SPI_74xx595_Write (uint8_t data);
extern uint8_t spi_mode;

