
#ifdef SUPPORT_LCD
#ifdef SUPPORT_DOGM128

#ifndef DOGM128_H
#define DOGM128_H

#define DOGM128_START_ADDR	0x40
#define DOGM128_ADC_REVERSE	0xA0
#define DOGM128_ADC_INVERT	0xA6
#define DOGM128_NORMAL_COM0_63	0xC0
#define DOGM128_NORMAL_COM63_0	0xC8
#define DOGM128_DISPLAY_NORMAL	0xA6
#define DOGM128_BIAS1_9		0xA2
#define DOGM128_BOOSTER_OFF	0x2B
#define DOGM128_BOOSTER_REG_FOL	0x2F
#define DOGM128_BOOSTER_4X	0xF8
#define DOGM128_CONTRAST_SET1	0x27
#define DOGM128_CONTRAST_SET2	0x81
#define DOGM128_CONTRAST_SET3	0x16
#define DOGM128_INDICATOR_NO1	0xAC
#define DOGM128_INDICATOR_NO2	0x00
#define DOGM128_DISPLAY_ON	0xAF

void DOGM128_Init (void);
void DOGM128_Update (void);

#endif

#endif
#endif


