#!/bin/sh
#
#


cat rc_lib/rc.h | grep -v "^$" | grep "_t Rc_" | grep -v "Cmd" | tr "[" " " | tr "]" " " | sed "s|^extern ||g" | sed "s|^volatile ||g" | sed "s|\;| |g" | awk '{print $2}' | cut -d"_" -f2 | grep -v "\<Flag\>" | grep -v "\<Servo\>" | grep -v "\<Calibrate\>" | grep -v "\<Model\>" | uniq > /tmp/menu.txt

for ENTRY in `cat /tmp/menu.txt`
do
	SEARCH="`cat rc_lib/rc.h | grep -v "^$" | grep "_t Rc_${ENTRY}_" | grep -v "Cmd" | tr "[" " " | tr "]" " " | sed "s|^extern ||g" | sed "s|^volatile ||g" | sed "s|\;| |g" | awk '{print $3}' | head -n1`"
	rm -rf /tmp/flag_single.tmp
	cat rc_lib/rc.h | grep -v "^$" | grep "_t Rc_${ENTRY}_" | grep -v "Cmd" | tr "[" " " | tr "]" " " | sed "s|^extern ||g" | sed "s|^volatile ||g" | sed "s|\;| |g" | awk '{print $3}' | while read LINE
	do
		if test "$SEARCH" != "$LINE"
		then
			echo > /tmp/flag_single.tmp
		fi
	done

	echo -n "0" > /tmp/size
	if ! echo "$SEARCH" | grep -s -q -i "[a-z]"
	then
		SEARCH=1
	fi
	if ! test -e /tmp/flag_single.tmp
	then
		N2="1"
		cat rc_lib/rc.h | grep -v "^$" | grep "_t Rc_${ENTRY}_" | grep -v "Cmd" | tr "[" " " | tr "]" " " | sed "s|^extern ||g" | sed "s|^volatile ||g" | sed "s|\;| |g" | while read LINE
		do
			TYPE="`echo "$LINE" | awk '{print $1}'`"
			NAME="`echo "$LINE" | awk '{print $2}'`"
			SUB_NAME="`echo "$NAME" | cut -d"_" -f3-`"
			SUB_TITLE="`echo "$SUB_NAME" | sed "s|_| |g"`"
			COMMENT="`echo "$LINE" | grep -s -q "// " && echo "$LINE" | sed "s|.*// ||g"`"
			LEN="`echo "$LINE" | awk '{print $3}'`"
			LEN2="`echo "$LINE" | awk '{print $4}' | sed "s|//.*||g"`"
			if test "$LEN2" != ""
			then
				if test "${SUB_NAME}" = "point"
				then
					echo -n "+ (7 * 2 * $SEARCH)" >> /tmp/size
				else
					echo -n " + $SEARCH" >> /tmp/size
				fi
			else 
				echo -n " + $SEARCH" >> /tmp/size
			fi
		done
	else
		N2="1"
		cat rc_lib/rc.h | grep -v "^$" | grep "_t Rc_${ENTRY}_" | grep -v "Cmd" | tr "[" " " | tr "]" " " | sed "s|^extern ||g" | sed "s|^volatile ||g" | sed "s|\;| |g" | while read LINE
		do
			TYPE="`echo "$LINE" | awk '{print $1}'`"
			NAME="`echo "$LINE" | awk '{print $2}'`"
			SUB_NAME="`echo "$NAME" | cut -d"_" -f3-`"
			SUB_TITLE="`echo "$SUB_NAME" | sed "s|_| |g"`"
			COMMENT="`echo "$LINE" | grep -s -q "// " && echo "$LINE" | sed "s|.*// ||g"`"
			echo -n " + $SEARCH" >> /tmp/size
		done
	fi
	echo "#define SIZEOF_$ENTRY		(`cat /tmp/size | sed "s|^0 + ||g"`)"
done
echo ""
echo ""
echo ""
echo "/* copy setup to buffer */"
echo ""
for ENTRY in `cat /tmp/menu.txt`
do
	COMMENT="`grep "^// *Rc_${ENTRY}:" /usr/src/RCos/rcos-stm32-0.1/rc_lib/rc.h | sed "s|.*: *||g"`"
	SEARCH="`cat rc_lib/rc.h | grep -v "^$" | grep "_t Rc_${ENTRY}_" | grep -v "Cmd" | tr "[" " " | tr "]" " " | sed "s|^extern ||g" | sed "s|^volatile ||g" | sed "s|\;| |g" | awk '{print $3}' | head -n1`"
	rm -rf /tmp/flag_single.tmp
	cat rc_lib/rc.h | grep -v "^$" | grep "_t Rc_${ENTRY}_" | grep -v "Cmd" | tr "[" " " | tr "]" " " | sed "s|^extern ||g" | sed "s|^volatile ||g" | sed "s|\;| |g" | awk '{print $3}' | while read LINE
	do
		if test "$SEARCH" != "$LINE"
		then
			echo > /tmp/flag_single.tmp
		fi
	done
	echo "// $COMMENT"
	echo "void Rc_Cmd_${ENTRY}_Get (uint8_t *buffer) {"
	echo "	uint16_t num = 0;"
	if ! echo "$SEARCH" | grep -s -q -i "[a-z]"
	then
		SEARCH=1
	fi
	if ! test -e /tmp/flag_single.tmp
	then
		N2="1"
		cat rc_lib/rc.h | grep -v "^$" | grep "_t Rc_${ENTRY}_" | grep -v "Cmd" | tr "[" " " | tr "]" " " | sed "s|^extern ||g" | sed "s|^volatile ||g" | sed "s|\;| |g" | while read LINE
		do
			TYPE="`echo "$LINE" | awk '{print $1}'`"
			NAME="`echo "$LINE" | awk '{print $2}'`"
			SUB_NAME="`echo "$NAME" | cut -d"_" -f3-`"
			SUB_TITLE="`echo "$SUB_NAME" | sed "s|_| |g"`"
			COMMENT="`echo "$LINE" | grep -s -q "// " && echo "$LINE" | sed "s|.*// ||g"`"
			LEN="`echo "$LINE" | awk '{print $3}'`"
			LEN2="`echo "$LINE" | awk '{print $4}' | sed "s|//.*||g"`"
			if test "$LEN2" != ""
			then
				if test "${SUB_NAME}" = "point"
				then
					echo "	memcpy(buffer + num, &Rc_${ENTRY}_${SUB_NAME}, (MIXER_POINTS_MAX * 2 * $SEARCH));"
					echo "	num += (MIXER_POINTS_MAX * 2 * $SEARCH);"
				else
					echo "	memcpy(buffer + num, &Rc_${ENTRY}_${SUB_NAME}, $SEARCH);"
					echo "	num += $SEARCH;"
				fi
			else 
				echo "	memcpy(buffer + num, &Rc_${ENTRY}_${SUB_NAME}, $SEARCH);"
				echo "	num += $SEARCH;"
			fi
		done
	else
		N2="1"
		cat rc_lib/rc.h | grep -v "^$" | grep "_t Rc_${ENTRY}_" | grep -v "Cmd" | tr "[" " " | tr "]" " " | sed "s|^extern ||g" | sed "s|^volatile ||g" | sed "s|\;| |g" | while read LINE
		do
			TYPE="`echo "$LINE" | awk '{print $1}'`"
			NAME="`echo "$LINE" | awk '{print $2}'`"
			SUB_NAME="`echo "$NAME" | cut -d"_" -f3-`"
			SUB_TITLE="`echo "$SUB_NAME" | sed "s|_| |g"`"
			COMMENT="`echo "$LINE" | grep -s -q "// " && echo "$LINE" | sed "s|.*// ||g"`"
			echo "	memcpy(buffer + num, &Rc_${ENTRY}_${SUB_NAME}, $SEARCH);"
			echo "	num += $SEARCH;"
		done
	fi
	echo "	return num;"
	echo "}"
	echo ""
done
echo ""
echo ""
echo "/* copy buffer to setup */"
echo ""
for ENTRY in `cat /tmp/menu.txt`
do
	COMMENT="`grep "^// *Rc_${ENTRY}:" /usr/src/RCos/rcos-stm32-0.1/rc_lib/rc.h | sed "s|.*: *||g"`"
	SEARCH="`cat rc_lib/rc.h | grep -v "^$" | grep "_t Rc_${ENTRY}_" | grep -v "Cmd" | tr "[" " " | tr "]" " " | sed "s|^extern ||g" | sed "s|^volatile ||g" | sed "s|\;| |g" | awk '{print $3}' | head -n1`"
	rm -rf /tmp/flag_single.tmp
	cat rc_lib/rc.h | grep -v "^$" | grep "_t Rc_${ENTRY}_" | grep -v "Cmd" | tr "[" " " | tr "]" " " | sed "s|^extern ||g" | sed "s|^volatile ||g" | sed "s|\;| |g" | awk '{print $3}' | while read LINE
	do
		if test "$SEARCH" != "$LINE"
		then
			echo > /tmp/flag_single.tmp
		fi
	done
	echo "// $COMMENT"
	echo "void Rc_Cmd_${ENTRY}_Set (uint8_t *buffer) {"
	if ! echo "$SEARCH" | grep -s -q -i "[a-z]"
	then
		SEARCH=1
	fi
	if ! test -e /tmp/flag_single.tmp
	then
		N2="1"
		cat rc_lib/rc.h | grep -v "^$" | grep "_t Rc_${ENTRY}_" | grep -v "Cmd" | tr "[" " " | tr "]" " " | sed "s|^extern ||g" | sed "s|^volatile ||g" | sed "s|\;| |g" | while read LINE
		do
			TYPE="`echo "$LINE" | awk '{print $1}'`"
			NAME="`echo "$LINE" | awk '{print $2}'`"
			SUB_NAME="`echo "$NAME" | cut -d"_" -f3-`"
			SUB_TITLE="`echo "$SUB_NAME" | sed "s|_| |g"`"
			COMMENT="`echo "$LINE" | grep -s -q "// " && echo "$LINE" | sed "s|.*// ||g"`"
			LEN="`echo "$LINE" | awk '{print $3}'`"
			LEN2="`echo "$LINE" | awk '{print $4}' | sed "s|//.*||g"`"
			if test "$LEN2" != ""
			then
				if test "${SUB_NAME}" = "point"
				then
					echo "	memcpy(&Rc_${ENTRY}_${SUB_NAME}, buffer, (7 * 2 * $SEARCH));"
					echo "	buffer += (7 * 2 * $SEARCH);"
				else
					echo "	memcpy(&Rc_${ENTRY}_${SUB_NAME}, buffer, $SEARCH);"
					echo "	buffer += $SEARCH;"
				fi
			else 
				echo "	memcpy(&Rc_${ENTRY}_${SUB_NAME}, buffer, $SEARCH);"
				echo "	buffer += $SEARCH;"
			fi
		done
	else
		N2="1"
		cat rc_lib/rc.h | grep -v "^$" | grep "_t Rc_${ENTRY}_" | grep -v "Cmd" | tr "[" " " | tr "]" " " | sed "s|^extern ||g" | sed "s|^volatile ||g" | sed "s|\;| |g" | while read LINE
		do
			TYPE="`echo "$LINE" | awk '{print $1}'`"
			NAME="`echo "$LINE" | awk '{print $2}'`"
			SUB_NAME="`echo "$NAME" | cut -d"_" -f3-`"
			SUB_TITLE="`echo "$SUB_NAME" | sed "s|_| |g"`"
			COMMENT="`echo "$LINE" | grep -s -q "// " && echo "$LINE" | sed "s|.*// ||g"`"
			echo "	memcpy(&Rc_${ENTRY}_${SUB_NAME}, buffer, $SEARCH);"
			echo "	buffer += $SEARCH;"
		done
	fi
	echo "}"
	echo ""
done

echo ""
echo ""
for ENTRY in `cat /tmp/menu.txt`
do
	COMMENT="`grep "^// *Rc_${ENTRY}:" /usr/src/RCos/rcos-stm32-0.1/rc_lib/rc.h | sed "s|.*: *||g"`"
	echo "// $COMMENT"
	echo "extern void Rc_Cmd_${ENTRY}_Set (uint8_t *buffer);"
	echo "extern void Rc_Cmd_${ENTRY}_Get (uint8_t *buffer);"
	echo ""
done

