#!/bin/sh
#
#


echo ""
cat rc_lib/rc.h | grep -v "^$" | grep "_t Rc_" | grep -v "Cmd" | tr "[" " " | tr "]" " " | sed "s|^extern ||g" | sed "s|^volatile ||g" | sed "s|\;| |g" | awk '{print $2}' | cut -d"_" -f2 | grep -v "\<Flag\>" | grep -v "\<Servo\>" | grep -v "\<Calibrate\>" | grep -v "\<Model\>" | uniq > /tmp/menu.txt

X_POS="14"
Y_POS="60"
Y="$Y_POS"
Y_DIFF="27"

X_POS2="35"
Y_POS2="35"
Y_DIFF2="32"

TITLE="Moskito-Sport"

HEADFONT="/usr/share/fonts/truetype/dustin/It_wasn_t_me.ttf"
HEADFONT_SIZE="30"

LCDFONT="/usr/share/fonts/truetype/LCDMonoWinTT/LCDMB___.TTF"
LCDFONT_SIZE="30"

FONT="/usr/share/fonts/truetype/ttf-liberation/LiberationMono-Regular.ttf"
FONT_SIZE="25"

PHPMENUFONT="/usr/share/fonts/truetype/dustin/It_wasn_t_me.ttf"
PHPMENUFONT_SIZE="65"
PHPMENUWIDTH="320"
PHPMENUHEIGHT="50"

BACKGROUND2="/usr/src/RCos/Website/lcd-2x20.png"
BACKGROUND="/usr/src/RCos/Website/dogm128.png"
BACKGROUND_MIXER="/usr/src/RCos/Website/dogm128_mixer.png"
OUTPUT_DIR="/usr/src/RCos/Website/lcd-menu"
HTML_IMAGES="lcd-menu"
HTML_MENU="/usr/src/RCos/Website/lite-menu.php"
HTML_MENU2="/usr/src/RCos/Website/lite-text-menu.php"
OUTPUT_HTML2="/usr/src/RCos/Website"
mkdir -p "$OUTPUT_DIR"



convert -fill white -pointsize $HEADFONT_SIZE -font $HEADFONT -gravity Center -pointsize 100 \
	-draw "text 0,0 'rCos'" \
	/usr/src/RCos/Website/button.png -scale x75 /usr/src/RCos/Website/title.png

convert -fill white -pointsize $HEADFONT_SIZE -font $HEADFONT -gravity Center -pointsize 100 \
	-draw "text 0,0 'one'" \
	/usr/src/RCos/Website/button.png -scale x40 /usr/src/RCos/Website/one.png

convert -fill white -pointsize $HEADFONT_SIZE -font $HEADFONT -gravity Center -pointsize 100 \
	-draw "text 0,0 'lite'" \
	/usr/src/RCos/Website/button.png -scale x40 /usr/src/RCos/Website/lite.png


for MENU in "logo RC-Elektronik" "info Allgemein" "plane Flugzeuge" "heli Hubschrauber" "function Funktions-Mod." "media Multimedia" "videos Videos" "downloads Downloads" "links Links"
do
	MENU_NAME="`echo "$MENU" | cut -d" " -f1`"
	MENU_TEXT="`echo "$MENU" | cut -d" " -f2-`"
	echo "$MENU_NAME ($MENU_TEXT)"
	convert -fill white -pointsize $PHPMENUFONT_SIZE -font $PHPMENUFONT -gravity Center \
		-draw "text 0,0 '$MENU_TEXT'" \
		/usr/src/RCos/Website/button.png -scale ${PHPMENUWIDTH}x${PHPMENUHEIGHT} /usr/src/RCos/Website/$MENU_NAME.png
done




echo "<? include \"head.inc\"; ?>" > "$HTML_MENU2"
echo "	<TABLE border=\"0\" width=\"100%\">" >> "$HTML_MENU2"
echo "	<TR>" >> "$HTML_MENU2"
echo "		<TD colspan=\"2\">" >> "$HTML_MENU2"
echo "			<H2><FONT color=\"#FFFFFF\">Haupt-Men&uuml;:</FONT></H2><HR>" >> "$HTML_MENU2"
echo "			<A href=\"lite.php\"><IMG border=\"0\" src=\"$HTML_IMAGES/lcd_text-back.png\"></A>" >> "$HTML_MENU2"
echo "			<A href=\"lite-menu.php\"><IMG border=\"0\" src=\"$HTML_IMAGES/lcd.png\"></A>" >> "$HTML_MENU2"
echo "			<HR>" >> "$HTML_MENU2"
echo "		</TD>" >> "$HTML_MENU2"
echo "	</TR>" >> "$HTML_MENU2"
echo "	<TD width=\"20\">" >> "$HTML_MENU2"
echo "	</TD><TD>" >> "$HTML_MENU2"
echo "		<TABLE border=\"0\" width=\"100%\">" >> "$HTML_MENU2"
echo "			<TR>" >> "$HTML_MENU2"



echo "<? include \"head.inc\"; ?>" > "$HTML_MENU"
echo "	<TABLE border=\"0\" width=\"100%\">" >> "$HTML_MENU"
echo "	<TR>" >> "$HTML_MENU"
echo "		<TD colspan=\"2\">" >> "$HTML_MENU"
echo "			<H2><FONT color=\"#FFFFFF\">Haupt-Men&uuml;:</FONT></H2><HR>" >> "$HTML_MENU"
echo "			<A href=\"lite.php\"><IMG border=\"0\" src=\"$HTML_IMAGES/lcd_back.png\"></A>" >> "$HTML_MENU"
echo "			<A href=\"lite-text-menu.php\"><IMG border=\"0\" src=\"$HTML_IMAGES/lcd_text.png\"></A>" >> "$HTML_MENU"
echo "			<HR>" >> "$HTML_MENU"
echo "		</TD>" >> "$HTML_MENU"
echo "	</TR>" >> "$HTML_MENU"
echo "	<TD width=\"20\">" >> "$HTML_MENU"
echo "	</TD><TD>" >> "$HTML_MENU"
echo "		<TABLE border=\"0\" width=\"100%\">" >> "$HTML_MENU"
echo "			<TR>" >> "$HTML_MENU"

Y="$Y_POS"
echo -n "convert -font $HEADFONT -fill black -pointsize $HEADFONT_SIZE -draw \"text $X_POS,$Y '$TITLE\" -font $FONT" > /tmp/conv.sh
echo " $BACKGROUND $OUTPUT_DIR/lcd_back.png" >> /tmp/conv.sh
echo -n "convert -fill black -font $FONT" >> /tmp/conv.sh
echo -n " -gravity Center -pointsize `expr $FONT_SIZE + 20` -draw \"text 0,20 '<-Back'\"" >> /tmp/conv.sh
echo " $OUTPUT_DIR/lcd_back.png /tmp/conv.png" >> /tmp/conv.sh
echo "convert -scale x75 /tmp/conv.png $OUTPUT_DIR/lcd_back.png" >> /tmp/conv.sh
sh /tmp/conv.sh

Y="$Y_POS2"
echo -n "convert -fill black -pointsize $LCDFONT_SIZE -font $LCDFONT" > /tmp/conv.sh
echo -n " -gravity Center -pointsize `expr $FONT_SIZE + 30` -draw \"text 0,0 '<-Back'\"" >> /tmp/conv.sh
echo " $BACKGROUND2 /tmp/conv.png" >> /tmp/conv.sh
echo "convert -scale x75 /tmp/conv.png $OUTPUT_DIR/lcd_text-back.png" >> /tmp/conv.sh
sh /tmp/conv.sh

Y="$Y_POS"
echo -n "convert -font $HEADFONT -fill black -pointsize $HEADFONT_SIZE -draw \"text $X_POS,$Y '$TITLE\" -font $FONT" > /tmp/conv.sh
echo " $BACKGROUND $OUTPUT_DIR/lcd.png" >> /tmp/conv.sh
echo -n "convert -fill black -font $FONT" >> /tmp/conv.sh
echo -n " -gravity Center -pointsize `expr $FONT_SIZE + 15` -draw \"text 0,-10 'Grafik'\"" >> /tmp/conv.sh
echo -n " -gravity Center -pointsize `expr $FONT_SIZE + 15` -draw \"text 0,30 '128x64'\"" >> /tmp/conv.sh
echo " $OUTPUT_DIR/lcd.png /tmp/conv.png" >> /tmp/conv.sh
echo "convert -scale x75 /tmp/conv.png $OUTPUT_DIR/lcd.png" >> /tmp/conv.sh
sh /tmp/conv.sh

Y="$Y_POS2"
echo -n "convert -fill black -pointsize $LCDFONT_SIZE -font $LCDFONT" > /tmp/conv.sh
echo -n " -gravity Center -pointsize `expr $FONT_SIZE + 30` -draw \"text 0,0 'Text 2x20'\"" >> /tmp/conv.sh
echo " $BACKGROUND2 /tmp/conv.png" >> /tmp/conv.sh
echo "convert -scale x75 /tmp/conv.png $OUTPUT_DIR/lcd_text.png" >> /tmp/conv.sh
sh /tmp/conv.sh


for ENTRY in `cat /tmp/menu.txt`
do
	SEARCH="`cat rc_lib/rc.h | grep -v "^$" | grep "_t Rc_${ENTRY}_" | grep -v "Cmd" | tr "[" " " | tr "]" " " | sed "s|^extern ||g" | sed "s|^volatile ||g" | sed "s|\;| |g" | awk '{print $3}' | head -n1`"
	rm -rf /tmp/flag_single.tmp
	cat rc_lib/rc.h | grep -v "^$" | grep "_t Rc_${ENTRY}_" | grep -v "Cmd" | tr "[" " " | tr "]" " " | sed "s|^extern ||g" | sed "s|^volatile ||g" | sed "s|\;| |g" | awk '{print $3}' | while read LINE
	do
		if test "$SEARCH" != "$LINE"
		then
			echo > /tmp/flag_single.tmp
		fi
	done
	if ! echo "$SEARCH" | grep -s -q -i "[a-z]"
	then
		SEARCH=1;
	fi

	COMMENT="`grep "^// *Rc_${ENTRY}:" /usr/src/RCos/rcos-stm32-0.1/rc_lib/rc.h | sed "s|.*: *||g"`"

	OUTPUT_HTML_TEXT="${OUTPUT_HTML2}/lite-text-menu_${ENTRY}.php"
	echo "<? include \"head.inc\"; ?>" > "$OUTPUT_HTML_TEXT"
	echo "	<TABLE border=\"0\" width=\"100%\">" >> "$OUTPUT_HTML_TEXT"
	echo "	<TR>" >> "$OUTPUT_HTML_TEXT"
	echo "		<TD colspan=\"2\">" >> "$OUTPUT_HTML_TEXT"
	echo "			<H2><FONT color=\"#FFFFFF\">Men&uuml; (${ENTRY}):</FONT></H2><HR>" >> "$OUTPUT_HTML_TEXT"
	echo "			<A href=\"lite-text-menu.php\"><IMG border=\"0\" src=\"$HTML_IMAGES/lcd_text-back.png\"></A>" >> "$OUTPUT_HTML_TEXT"
	echo "			<A href=\"lite-menu_${ENTRY}.php\"><IMG border=\"0\" src=\"$HTML_IMAGES/lcd.png\"></A>" >> "$OUTPUT_HTML_TEXT"
	echo "			<HR>" >> "$OUTPUT_HTML_TEXT"
	echo "		</TD>" >> "$OUTPUT_HTML_TEXT"
	echo "	</TR>" >> "$OUTPUT_HTML_TEXT"
	echo "	<TD width=\"20\">" >> "$OUTPUT_HTML_TEXT"
	echo "	</TD><TD>" >> "$OUTPUT_HTML_TEXT"
	echo "		<TABLE border=\"0\" width=\"100%\">" >> "$OUTPUT_HTML_TEXT"
	echo "			<TR>" >> "$OUTPUT_HTML_TEXT"

	OUTPUT_HTML="${OUTPUT_HTML2}/lite-menu_${ENTRY}.php"
	echo "<? include \"head.inc\"; ?>" > "$OUTPUT_HTML"
	echo "	<TABLE border=\"0\" width=\"100%\">" >> "$OUTPUT_HTML"
	echo "	<TR>" >> "$OUTPUT_HTML"
	echo "		<TD colspan=\"2\">" >> "$OUTPUT_HTML"
	echo "			<H2><FONT color=\"#FFFFFF\">Men&uuml; (${ENTRY}):</FONT></H2><HR>" >> "$OUTPUT_HTML"
	echo "			<A href=\"lite-menu.php\"><IMG border=\"0\" src=\"$HTML_IMAGES/lcd_back.png\"></A>" >> "$OUTPUT_HTML"
	echo "			<A href=\"lite-text-menu_${ENTRY}.php\"><IMG border=\"0\" src=\"$HTML_IMAGES/lcd_text.png\"></A>" >> "$OUTPUT_HTML"
	echo "			<HR>" >> "$OUTPUT_HTML"
	echo "		</TD>" >> "$OUTPUT_HTML"
	echo "	</TR>" >> "$OUTPUT_HTML"
	echo "	<TD width=\"20\">" >> "$OUTPUT_HTML"
	echo "	</TD><TD>" >> "$OUTPUT_HTML"
	echo "		<TABLE border=\"0\" width=\"100%\">" >> "$OUTPUT_HTML"
	echo "			<TR>" >> "$OUTPUT_HTML"



	Y="$Y_POS"
	echo -n "convert -fill black -pointsize $LCDFONT_SIZE -font $LCDFONT" > /tmp/conv.sh
	echo -n " -gravity Center -pointsize `expr $FONT_SIZE + 30` -draw \"text 0,0 '$ENTRY'\"" >> /tmp/conv.sh
	echo " $BACKGROUND2 /tmp/conv.png" >> /tmp/conv.sh
	echo "convert -scale 100x /tmp/conv.png $OUTPUT_DIR/lcd_text-${ENTRY}.png" >> /tmp/conv.sh
	sh /tmp/conv.sh

	echo "		<TR>" >> "$HTML_MENU2"
	echo "			<TD width=\"140\">" >> "$HTML_MENU2"
	echo "				<A href=\"lite-text-menu_${ENTRY}.php\"><IMG border=\"0\" src=\"$HTML_IMAGES/lcd_text-${ENTRY}.png\"></A>" >> "$HTML_MENU2"
	echo "			</TD><TD>" >> "$HTML_MENU2"
	echo "				<A href=\"lite-text-menu_${ENTRY}.php\"><FONT color=\"#FFFFFF\">${ENTRY}</FONT></A><BR>" >> "$HTML_MENU2"
	echo "				<FONT color=\"#FFFFFF\">$COMMENT</FONT>" >> "$HTML_MENU2"
	echo "			</TD>" >> "$HTML_MENU2"
	echo "		</TR>" >> "$HTML_MENU2"


	Y="$Y_POS"
	echo -n "convert -font $HEADFONT -fill black -pointsize $HEADFONT_SIZE -draw \"text $X_POS,$Y '$TITLE\" -font $FONT" > /tmp/conv.sh
	echo " $BACKGROUND $OUTPUT_DIR/lcd_${ENTRY}.png" >> /tmp/conv.sh
	echo -n "convert -fill black -font $FONT" >> /tmp/conv.sh
	echo -n " -gravity Center -pointsize `expr $FONT_SIZE + 3` -draw \"text 0,20 '$ENTRY'\"" >> /tmp/conv.sh
	echo " $OUTPUT_DIR/lcd_${ENTRY}.png /tmp/conv.png" >> /tmp/conv.sh
	echo "convert -scale 100x /tmp/conv.png $OUTPUT_DIR/lcd_${ENTRY}.png" >> /tmp/conv.sh
	sh /tmp/conv.sh

	echo "		<TR>" >> "$HTML_MENU"
	echo "			<TD width=\"140\">" >> "$HTML_MENU"
	echo "				<A href=\"lite-menu_${ENTRY}.php\"><IMG border=\"0\" src=\"$HTML_IMAGES/lcd_${ENTRY}.png\"></A>" >> "$HTML_MENU"
	echo "			</TD><TD>" >> "$HTML_MENU"
	echo "				<A href=\"lite-menu_${ENTRY}.php\"><FONT color=\"#FFFFFF\">${ENTRY}</FONT></A><BR>" >> "$HTML_MENU"
	echo "				<FONT color=\"#FFFFFF\">$COMMENT</FONT>" >> "$HTML_MENU"
	echo "			</TD>" >> "$HTML_MENU"
	echo "		</TR>" >> "$HTML_MENU"

	if ! test -e /tmp/flag_single.tmp
	then
		N2="1"
		cat rc_lib/rc.h | grep -v "^$" | grep "_t Rc_${ENTRY}_" | grep -v "Cmd" | grep -v "_buffer" | grep -v "_values" | tr "[" " " | tr "]" " " | sed "s|^extern ||g" | sed "s|^volatile ||g" | sed "s|\;| |g" | while read LINE
		do
			TYPE="`echo "$LINE" | awk '{print $1}'`"
			NAME="`echo "$LINE" | awk '{print $2}'`"
			SUB_NAME="`echo "$NAME" | cut -d"_" -f3-`"
			SUB_TITLE="`echo "$SUB_NAME" | sed "s|_| |g"`"
			COMMENT="`echo "$LINE" | grep -s -q "// " && echo "$LINE" | sed "s|.*// ||g"`"
			LEN="`echo "$LINE" | awk '{print $3}'`"
			LEN2="`echo "$LINE" | awk '{print $4}' | sed "s|//.*||g"`"
			if test "$LEN2" != ""
			then


				echo "			<TR>" >> "$OUTPUT_HTML_TEXT"
				echo "			<TD colspan=\"3\"><H3><FONT color=\"#FFFFFF\">${SUB_TITLE}:</FONT></H3><HR></TD>" >> "$OUTPUT_HTML_TEXT"
				echo "			</TR><TR>" >> "$OUTPUT_HTML_TEXT"


				echo "			<TR>" >> "$OUTPUT_HTML"
				echo "			<TD colspan=\"3\"><H3><FONT color=\"#FFFFFF\">${SUB_TITLE}:</FONT></H3><HR></TD>" >> "$OUTPUT_HTML"
				echo "			</TR><TR>" >> "$OUTPUT_HTML"


				Y2="$Y_POS2"
				echo -n "convert -fill black -pointsize $LCDFONT_SIZE -font $LCDFONT" > /tmp/conv2.sh
				Y2="`expr $Y2 + $Y_DIFF2`"
				echo -n " -pointsize $FONT_SIZE -draw \"text $X_POS2,$Y2 '$ENTRY ($((RANDOM % 16)))'\"" >> /tmp/conv2.sh
				Y2="`expr $Y2 + $Y_DIFF2`"

				Y="$Y_POS"
				echo -n "convert -font $HEADFONT -fill black -pointsize $HEADFONT_SIZE -draw \"text $X_POS,$Y '$TITLE\" -font $FONT" > /tmp/conv.sh
				Y="`expr $Y + $Y_DIFF`"
				echo -n " -pointsize $FONT_SIZE -draw \"text $X_POS,$Y '$ENTRY ($((RANDOM % 16)))'\"" >> /tmp/conv.sh
				Y="`expr $Y + $Y_DIFF`"

				if test "${SUB_NAME}" = "point"
				then
					echo -n " -pointsize $FONT_SIZE -draw \"text $X_POS2,$Y2 '`echo "$SUB_TITLE 3,x" | cut -b1-10`'\"" >> /tmp/conv2.sh
					X2="`expr $X + 200`"
					echo -n " -pointsize $FONT_SIZE -draw \"text $X2,$Y2 '$((RANDOM % 100))'\"" >> /tmp/conv2.sh

					echo -n " -pointsize $FONT_SIZE -draw \"text $X_POS,$Y '$SUB_TITLE ($((RANDOM % 7)))'\"" >> /tmp/conv.sh
					Y="`expr $Y + $Y_DIFF`"
					Y="`expr $Y + $Y_DIFF`"
					echo -n " -pointsize $FONT_SIZE -draw \"text $X_POS,$Y 'x60'\"" >> /tmp/conv.sh
					Y="`expr $Y + $Y_DIFF`"
					echo -n " -pointsize $FONT_SIZE -draw \"text $X_POS,$Y 'y45'\"" >> /tmp/conv.sh
					echo " $BACKGROUND_MIXER $OUTPUT_DIR/lcd_${ENTRY}_${SUB_NAME}.png" >> /tmp/conv.sh
				else
					echo -n " -pointsize $FONT_SIZE -draw \"text $X_POS2,$Y2 '`echo "$SUB_TITLE" | cut -b1-10`'\"" >> /tmp/conv2.sh
					X2="`expr $X + 200`"
					echo -n " -pointsize $FONT_SIZE -draw \"text $X2,$Y2 '$((RANDOM % 100))'\"" >> /tmp/conv2.sh

					echo -n " -pointsize $FONT_SIZE -draw \"text $X_POS,$Y '$SUB_TITLE'\"" >> /tmp/conv.sh
					echo " $BACKGROUND $OUTPUT_DIR/lcd_${ENTRY}_${SUB_NAME}.png" >> /tmp/conv.sh
				fi

				echo " $BACKGROUND2 $OUTPUT_DIR/lcd_text-${ENTRY}_${SUB_NAME}.png" >> /tmp/conv2.sh
				sh /tmp/conv2.sh

				sh /tmp/conv.sh

				echo "				<TD>&nbsp;</TD>" >> "$OUTPUT_HTML_TEXT"
				echo "				<TD valign=\"top\"><FONT color=\"#FFFFFF\">$COMMENT</FONT></TD>" >> "$OUTPUT_HTML_TEXT"
				echo "				<TD width=\"1%\"><IMG border=\"0\" src=\"$HTML_IMAGES/lcd_text-${ENTRY}_${SUB_NAME}.png\"></TD>" >> "$OUTPUT_HTML_TEXT"

				echo "				<TD>&nbsp;</TD>" >> "$OUTPUT_HTML"
				echo "				<TD valign=\"top\"><FONT color=\"#FFFFFF\">$COMMENT</FONT></TD>" >> "$OUTPUT_HTML"
				echo "				<TD width=\"1%\"><IMG border=\"0\" src=\"$HTML_IMAGES/lcd_${ENTRY}_${SUB_NAME}.png\"></TD>" >> "$OUTPUT_HTML"

				continue;
			fi

			echo "			<TR>" >> "$OUTPUT_HTML_TEXT"
			echo "			<TD colspan=\"3\"><H3><FONT color=\"#FFFFFF\">${SUB_TITLE}:</FONT></H3><HR></TD>" >> "$OUTPUT_HTML_TEXT"
			echo "			</TR><TR>" >> "$OUTPUT_HTML_TEXT"

			echo "			<TR>" >> "$OUTPUT_HTML"
			echo "			<TD colspan=\"3\"><H3><FONT color=\"#FFFFFF\">${SUB_TITLE}:</FONT></H3><HR></TD>" >> "$OUTPUT_HTML"
			echo "			</TR><TR>" >> "$OUTPUT_HTML"



			Y2="$Y_POS2"
			echo -n "convert -fill black -pointsize $LCDFONT_SIZE -font $LCDFONT" > /tmp/conv2.sh
			Y2="`expr $Y2 + $Y_DIFF2`"
			echo -n " -pointsize $FONT_SIZE -draw \"text $X_POS2,$Y2 '$ENTRY ($((RANDOM % 16)))'\"" >> /tmp/conv2.sh
			Y2="`expr $Y2 + $Y_DIFF2`"
			echo -n " -pointsize $FONT_SIZE -draw \"text $X_POS2,$Y2 '`echo "$SUB_TITLE" | cut -b1-10`'\"" >> /tmp/conv2.sh
			X2="`expr $X + 200`"

			Y="$Y_POS"
			echo -n "convert -font $HEADFONT -fill black -pointsize $HEADFONT_SIZE -draw \"text $X_POS,$Y '$TITLE\" -font $FONT" > /tmp/conv.sh
			Y="`expr $Y + $Y_DIFF`"
			echo -n " -pointsize $FONT_SIZE -draw \"text $X_POS,$Y '$ENTRY ($((RANDOM % 16)))'\"" >> /tmp/conv.sh
			Y="`expr $Y + $Y_DIFF`"
			echo -n " -pointsize $FONT_SIZE -draw \"text $X_POS,$Y '$SUB_TITLE'\"" >> /tmp/conv.sh
			Y="`expr $Y + $Y_DIFF`"
			Y="`expr $Y + $Y_DIFF`"

			if echo "$SUB_NAME" | grep -s -q "control"
			then
				echo -n " -pointsize $FONT_SIZE -draw \"text $X2,$Y2 'Geber-E'\"" >> /tmp/conv2.sh
				echo -n " -pointsize $FONT_SIZE -draw \"text $X_POS,$Y '     Geber-E'\"" >> /tmp/conv.sh
			elif echo "$SUB_NAME" | grep -s -q "switch"
			then
				echo -n " -pointsize $FONT_SIZE -draw \"text $X2,$Y2 'Geber-F'\"" >> /tmp/conv2.sh
				echo -n " -pointsize $FONT_SIZE -draw \"text $X_POS,$Y '     Geber-F'\"" >> /tmp/conv.sh
			elif echo "$SUB_NAME" | grep -s -q "channel_in"
			then
				echo -n " -pointsize $FONT_SIZE -draw \"text $X2,$Y2 'Roll'\"" >> /tmp/conv2.sh
				echo -n " -pointsize $FONT_SIZE -draw \"text $X_POS,$Y '      Roll'\"" >> /tmp/conv.sh
			elif echo "$SUB_NAME" | grep -s -q "channel_out"
			then
				echo -n " -pointsize $FONT_SIZE -draw \"text $X2,$Y2 'Roll-Links'\"" >> /tmp/conv2.sh
				echo -n " -pointsize $FONT_SIZE -draw \"text $X_POS,$Y '   Roll-Links'\"" >> /tmp/conv.sh
			elif echo "$SUB_NAME" | grep -s -q "channel"
			then
				if test "${ENTRY}" = "Expo" || test "${ENTRY}" = "Dualrate"
				then
					echo -n " -pointsize $FONT_SIZE -draw \"text $X2,$Y2 'Nick'\"" >> /tmp/conv2.sh
					echo -n " -pointsize $FONT_SIZE -draw \"text $X_POS,$Y '      Nick'\"" >> /tmp/conv.sh
				elif test "${ENTRY}" = "Limiter" || test "${ENTRY}" = "Atv"
				then
					echo -n " -pointsize $FONT_SIZE -draw \"text $X2,$Y2 'Roll-Rechts'\"" >> /tmp/conv2.sh
					echo -n " -pointsize $FONT_SIZE -draw \"text $X_POS,$Y '   Roll-Rechts'\"" >> /tmp/conv.sh
				else
					echo -n " -pointsize $FONT_SIZE -draw \"text $X2,$Y2 'CH-15'\"" >> /tmp/conv2.sh
					echo -n " -pointsize $FONT_SIZE -draw \"text $X_POS,$Y '      CH-15'\"" >> /tmp/conv.sh
				fi
			elif test $ENTRY = "Expo" && echo "$SUB_NAME" | grep -s -q "type"
			then
				echo -n " -pointsize $FONT_SIZE -draw \"text $X2,$Y2 'Normal'\"" >> /tmp/conv2.sh
				echo -n " -pointsize $FONT_SIZE -draw \"text $X_POS,$Y '      Normal'\"" >> /tmp/conv.sh
			elif test $ENTRY = "Motion" && echo "$SUB_NAME" | grep -s -q "type"
			then
				echo -n " -pointsize $FONT_SIZE -draw \"text $X2,$Y2 'Speed-In'\"" >> /tmp/conv2.sh
				echo -n " -pointsize $FONT_SIZE -draw \"text $X_POS,$Y '    Speed-In'\"" >> /tmp/conv.sh
			else
				echo -n " -pointsize $FONT_SIZE -draw \"text $X2,$Y2 '($((RANDOM % 100)))'\"" >> /tmp/conv2.sh
				echo -n " -pointsize $FONT_SIZE -draw \"text $X_POS,$Y '        $((RANDOM % 100))      '\"" >> /tmp/conv.sh
			fi
			echo " $BACKGROUND2 $OUTPUT_DIR/lcd_${ENTRY}_${SUB_NAME}_text.png" >> /tmp/conv2.sh
			echo " $BACKGROUND $OUTPUT_DIR/lcd_${ENTRY}_${SUB_NAME}.png" >> /tmp/conv.sh


			sh /tmp/conv2.sh
			echo "				<TD>&nbsp;</TD>" >> "$OUTPUT_HTML_TEXT"
			echo "				<TD valign=\"top\"><FONT color=\"#FFFFFF\">$COMMENT</FONT></TD>" >> "$OUTPUT_HTML_TEXT"
			echo "				<TD width=\"1%\"><IMG border=\"0\" src=\"$HTML_IMAGES/lcd_${ENTRY}_${SUB_NAME}_text.png\"></TD>" >> "$OUTPUT_HTML_TEXT"

			sh /tmp/conv.sh
			echo "				<TD>&nbsp;</TD>" >> "$OUTPUT_HTML"
			echo "				<TD valign=\"top\"><FONT color=\"#FFFFFF\">$COMMENT</FONT></TD>" >> "$OUTPUT_HTML"
			echo "				<TD width=\"1%\"><IMG border=\"0\" src=\"$HTML_IMAGES/lcd_${ENTRY}_${SUB_NAME}.png\"></TD>" >> "$OUTPUT_HTML"
		done
	else
		N2="1"
		cat rc_lib/rc.h | grep -v "^$" | grep "_t Rc_${ENTRY}_" | grep -v "Cmd" | grep -v "_buffer" | grep -v "_values" | tr "[" " " | tr "]" " " | sed "s|^extern ||g" | sed "s|^volatile ||g" | sed "s|\;| |g" | while read LINE
		do
			TYPE="`echo "$LINE" | awk '{print $1}'`"
			NAME="`echo "$LINE" | awk '{print $2}'`"
			SUB_NAME="`echo "$NAME" | cut -d"_" -f3-`"
			SUB_TITLE="`echo "$SUB_NAME" | sed "s|_| |g"`"
			COMMENT="`echo "$LINE" | grep -s -q "// " && echo "$LINE" | sed "s|.*// ||g"`"


			echo "			<TR>" >> "$OUTPUT_HTML_TEXT"
			echo "			<TD colspan=\"3\"><H3><FONT color=\"#FFFFFF\">${SUB_TITLE}:</FONT></H3><HR></TD>" >> "$OUTPUT_HTML_TEXT"
			echo "			</TR><TR>" >> "$OUTPUT_HTML_TEXT"

			Y2="$Y_POS2"
			echo -n "convert -fill black -pointsize $LCDFONT_SIZE -font $LCDFONT" > /tmp/conv2.sh
			Y2="`expr $Y2 + $Y_DIFF2`"
			echo -n " -pointsize $FONT_SIZE -draw \"text $X_POS2,$Y2 '$ENTRY ($((RANDOM % 16)))'\"" >> /tmp/conv2.sh
			Y2="`expr $Y2 + $Y_DIFF2`"
			echo -n " -pointsize $FONT_SIZE -draw \"text $X_POS2,$Y2 '`echo "$SUB_TITLE" | cut -b1-10`'\"" >> /tmp/conv2.sh
			X2="`expr $X + 200`"
			echo -n " -pointsize $FONT_SIZE -draw \"text $X2,$Y2 '$((RANDOM % 100))'\"" >> /tmp/conv2.sh
			echo " $BACKGROUND2 $OUTPUT_DIR/lcd_text-${ENTRY}_${SUB_NAME}.png" >> /tmp/conv2.sh
			sh /tmp/conv2.sh
			echo "			<TD>&nbsp;</TD>" >> "$OUTPUT_HTML_TEXT"
			echo "			<TD valign=\"top\"><FONT color=\"#FFFFFF\">$COMMENT</FONT></TD>" >> "$OUTPUT_HTML_TEXT"
			echo "			<TD width=\"1%\"><IMG border=\"0\" src=\"$HTML_IMAGES/lcd_text-${ENTRY}_${SUB_NAME}.png\"></TD>" >> "$OUTPUT_HTML_TEXT"


			echo "			<TR>" >> "$OUTPUT_HTML"
			echo "			<TD colspan=\"3\"><H3><FONT color=\"#FFFFFF\">${SUB_TITLE}:</FONT></H3><HR></TD>" >> "$OUTPUT_HTML"
			echo "			</TR><TR>" >> "$OUTPUT_HTML"
			Y="$Y_POS"
			echo -n "convert -font $HEADFONT -fill black -pointsize $HEADFONT_SIZE -draw \"text $X_POS,$Y '$TITLE\" -font $FONT" > /tmp/conv.sh
			Y="`expr $Y + $Y_DIFF`"
			echo -n " -pointsize $FONT_SIZE -draw \"text $X_POS,$Y '$ENTRY'\"" >> /tmp/conv.sh
			Y="`expr $Y + $Y_DIFF`"
			echo -n " -pointsize $FONT_SIZE -draw \"text $X_POS,$Y '$SUB_TITLE'\"" >> /tmp/conv.sh
			Y="`expr $Y + $Y_DIFF`"
			Y="`expr $Y + $Y_DIFF`"
			echo -n " -pointsize $FONT_SIZE -draw \"text $X_POS,$Y '        $((RANDOM % 100))      '\"" >> /tmp/conv.sh
			echo " $BACKGROUND $OUTPUT_DIR/lcd_${ENTRY}_${SUB_NAME}.png" >> /tmp/conv.sh
			sh /tmp/conv.sh
			echo "			<TD>&nbsp;</TD>" >> "$OUTPUT_HTML"
			echo "			<TD valign=\"top\"><FONT color=\"#FFFFFF\">$COMMENT</FONT></TD>" >> "$OUTPUT_HTML"
			echo "			<TD width=\"1%\"><IMG border=\"0\" src=\"$HTML_IMAGES/lcd_${ENTRY}_${SUB_NAME}.png\"></TD>" >> "$OUTPUT_HTML"
		done
	fi
	echo "			</TR>" >> "$OUTPUT_HTML"
	echo "		</TABLE>" >> "$OUTPUT_HTML"
	echo "	 </TD>" >> "$OUTPUT_HTML"
	echo "	</TR>" >> "$OUTPUT_HTML"
	echo "	</TABLE>" >> "$OUTPUT_HTML"
done

echo "			</TR>" >> "$HTML_MENU"
echo "		</TABLE>" >> "$HTML_MENU"
echo "	 </TD>" >> "$HTML_MENU"
echo "	</TR>" >> "$HTML_MENU"
echo "	</TABLE>" >> "$HTML_MENU"



echo "<? include \"foot.inc\"; ?>" >> "$OUTPUT_HTML"


